#if !defined HAVE_COMBLEX_H__
#define      HAVE_COMBLEX_H__

#include "bitcombination.h"
#include "fxttypes.h"

#include "fxtio.h"


class comb_lex
{
public:
    comb_lex(ulong n, ulong k);
    ~comb_lex();

    ulong first()
    {
        bits_ = first_comb(k_);
        sync_x();
        return bits_;
    }

    ulong next()  // return zero if previous comb was the last
    {
        bits_ = next_comb(bits_);
        sync_x();
        return ( (bits_ & mask_) ? 0 : bits_ );
    }

    const ulong * data()  { return x_; }
    const comb_lex &  current()  const  { return *this; }

    friend ostream & operator << (ostream &os, const comb_lex &x);

//private:
    void sync_x();

//private:
    ulong n_;
    ulong k_;
    ulong bits_;
    ulong mask_;  // 111...111000..00 (n zeros)
    ulong *x_;
};
//---------------------



#endif  // !defined HAVE_COMBLEX_H__
