#if !defined HAVE_COMBNUM_H__
#define      HAVE_COMBNUM_H__

#include "bitcombination.h"
#include "fxttypes.h"

#include "fxtio.h"


class comb_num
{
public:
    comb_num(ulong n, ulong k);
    ~comb_num();

    ulong first()
    {
        xbits_ = first_comb(n_-k_);
        sync_x();
        return bits_;
    }

    ulong next()  // return zero if previous comb was the last
    {
        xbits_ = next_comb(xbits_);
        sync_x();
        return ( (xbits_ & mask_) ? 0 : xbits_ );
    }

    const ulong * data()  { return x_; }
    const comb_num &  current()  const  { return *this; }

    friend ostream & operator << (ostream &os, const comb_num &x);

//private:
    void sync_x();

//private:
    ulong n_;
    ulong k_;
    ulong bits_;
    ulong xbits_;
    ulong mask_;  // 111...111000..00 (n zeros)
    ulong nmask_;  // ~mask_
    ulong *x_;
};
//---------------------



#endif  // !defined HAVE_COMBNUM_H__
