#if !defined HAVE_QUANTISE_H__
#define      HAVE_QUANTISE_H__

#include "fxttypes.h"

#include <cmath> // floor()


void
quantise(double *f, ulong n, double q)
// in f[] set each element x to q*floor(1/q*(x+q/2))
// e.g.: q=1 ==> round to nearest integer
//       q=1/1000 ==> round to nearest multiple of 1/1000
{
    double qh = q * 0.5;
    double q1 = 1.0 / q;
    while ( n-- )
    {
        f[n] = q * floor( q1 * (f[n]+qh) );
    }
}
//-----------------------


#endif // !defined HAVE_QUANTISE_H__
